#
## https://www.statmethods.net/stats/descriptives.html
#

library(MASS)
data("Cars93")

# la media para las variables de precios

colMeans(Cars93[,4:6], na.rm = TRUE)
# rowMeans()
# colSums()
# rowSums()

# con sapply()
sapply(Cars93[,4:6], mean, na.rm=T)
sapply(Cars93[,4:6], max, na.rm=T)
# mean, sd, var, min, max, median, range, and quantile.

# mean,median,25th and 75th quartiles,min,max
summary(Cars93[,4:6])

# Tukey min,lower-hinge, median,upper-hinge,max
fivenum(Cars93[,4:6])

# Using the Hmisc package
library(Hmisc)
dd <- describe(Cars93[,4:6])
dd
# Info: is related to how continuous the variable is
# Gmd = Gini's Mean Difference: a measure of variability for non-normal distributions
plot(dd)

# Using the psych package
library(psych)
dd <- describe(Cars93[,4:6])

describeBy(Cars93[,4:6], group = Origin)
