help(data)
attach(cars)
help(cars)
lm(dist~speed)

plot(speed,dist)
abline(lm(dist~speed))

help(lm)
cotxes.lm<-lm(dist~speed)
cotxes.lm$residuals
plot(cotxes.lm$residuals)
plot(resid(cotxes.lm))
help(abline)
abline(h=0)
detach(cars)

x<-seq(0,4,by=.1)
plot(x,x^2,type="l")
curve(x^2,0,4)

plot.f <- function(f,a,b,...) {
xvals<-seq(a,b,length=100)
plot(xvals,f(xvals),type="l",...)}
plot.f(sin,0,2*pi)
plot.f(sin,0,2*pi,lty=4)
curve(sin,0,2*pi)

x<-runif(100)
hist(x,probability=TRUE,col=gray(.9),main="Uniforme [0,1]")
lines(c(0,1),c(1,1))
hist(x,probability=TRUE,col=5,main="Uniforme [0,1]")
curve(dunif(x,0,1),add=T)

x<-rexp(100,1/2500)
hist(x,probability=TRUE,col=6,main="Exponencial mitjana=2500")
curve(dexp(x,1/2500),add=T)

n<-5;p<-.25
xvals<-0:n
plot(xvals,dbinom(xvals,n,p),type="h",lwd=3)
plot(xvals,dbinom(xvals,n,p),type="p")


attach(iris)
x<-Sepal.Length
x1<-Sepal.Length[Species=="setosa"]
x2<-Sepal.Length[Species=="versicolor"]
x3<-Sepal.Length[Species=="virginica"]

# Un grfico sencillo de mnimos y mximos

plot(c(0,4), range(x), type='n', xlab='Specie', ylab='Sepal.Length', xaxt="n")
axis(1, at=1:3, labels=levels(Species))
arrows(x0=1:3, y0=c(min(x1),min(x2),min(x3)),
       x1=1:3, y1=c(max(x1),max(x2),max(x3)), code=3)
title('Mnimo y mximo')

# Un grfico ms sofisticado

plot(c(0,4), range(x), type='n', xlab='Specie', ylab='Sepal.Length', xaxt="n")
axis(1, at=1:3, labels=levels(Species))
segments(x0=1:3, y0=min(x), x1=1:3, y1=max(x), lwd=14, col="lightblue")
segments(x0=1:3, y0=c(min(x1),min(x2),min(x3)),
         x1=1:3, y1=c(max(x1),max(x2),max(x3)), lwd=10, col="blue")
title('Mnimo y mximo')

# Un grfico de barras especial

tN <- table(Ni <- rpois(100, lambda=5))

r <- barplot(tN, ylim=c(0,max(tN)+2), main="Datos de Poisson", col=rainbow(20))
text(r, tN, labels=tN, pos=3, col=rainbow(20))


