data (longley)
g <- lm (Employed ~ GNP + Population, longley)

summary(g, cor=T)
cor(longley$GNP, longley$Population)

plot(g, which=1) # ¿Posible autocorrelación?

( rho.est <- cor( residuals(g)[-1], residuals(g)[-16]) )

# matriz Sigma
x <- model.matrix(g)
Sigma <- diag(16)
Sigma <- rho.est^abs(row(Sigma)-col(Sigma))

sm <- chol(Sigma)
Sigma.inv <- chol2inv(sm)
xtxi <- solve(t(x) %*% Sigma.inv %*% x)
beta <- solve(t(x) %*% Sigma.inv %*% x, t(x) %*% Sigma.inv %*% longley$Empl)
beta

res <- longley$Empl - x %*% beta
# residual standard error
sigma <- sqrt( (t(res) %*% Sigma.inv %*% res)/g$df)
sigma
# errores estandar de las estimaciones
summary(g)$coef[,2]           # modelo ordinario
sqrt( diag(xtxi) ) * sigma    # modelo con autocorrelación

## Otra forma
smi <- solve(t(sm))
sx <- smi %*% x
sy <- smi %*% longley$Empl
summary(lm(sy ~ 0 + sx))

rho.est
rho.est_2 <- cor(res[-1], res[-16])
rho.est_2 # deberíamos iterar hasta la convergencia

## Con el paquete nlme
library(nlme)
g <- gls(Employed ~ GNP + Population,
         correlation=corAR1(form= ~ Year), data=longley)
summary(g) # Phi es rho

# ¿rho es cero?
intervals(g) # el intervalo para Phi no es significativamente diferente de cero
             # luego no hay evidencia estadística de autocorrelación
