################
## Dynamite Plot
################

# Referencies
# Dynamite plots: unmitigated evil? 
# http://emdbolker.wikidot.com/blog%3Adynamite
# 
# Why dynamite plots are BAD 
# http://pablomarin-garcia.blogspot.co.nz/2010/02/why-dynamite-plots-are-bad.html
#
# Beware of Dynamite 
# http://biostat.mc.vanderbilt.edu/wiki/pub/Main/TatsukiKoyama/Poster3.pdf

dynamitePlot <- function(height, error, names = NA,
                         significance = NA, ylim = c(0,maxLim), ...){
  maxLim <- 1.1* max(mapply(sum, height, error))
  bp <- barplot(height, names.arg = names, ylim = ylim, ...)
  arrows(x0 = bp, y0 = height, y1 = height + error, angle = 90)
  text(x = bp, y = 0.2 + height + error, labels = significance)
}

Values <- c(1,2,5,4)
Errors <- c(0.25, 0.5, 0.33, 0.12)
Names <- paste("Trial", 1:4)
Sig <- c("a", "a", "b", "b")

dynamitePlot(Values, Errors, names = Names, significance = Sig)