## Un gráfico desde cero

x <- rnorm(20)
y <- rnorm(20)

oldpar <- par(bg="lightgray", mar=c(2.5,1.5,2.5,0.25))

plot(x,y, type="n", xlab="", ylab="", xlim=c(-2,2), ylim=c(-2,2), xaxt="n", yaxt="n")
rect(-3,-3,3,3, col="cornsilk")
points(x, y, pch=10, col="red", cex=2)

axis(side=1, c(-2,0,2), labels=FALSE)
axis(side=2, -1:1, labels=FALSE)

title("Realizando un gráfico desde cero", font.main=4, adj=1, cex.main=1)

mtext("20 números de N(0,1)", side=1, line=1, at=1, cex=0.9, font=3 )
mtext("N(0,1)", line=0.5, at=-1.8, cex=0.9, font=3)
mtext(c(-2,0,2), side=1, las=1, at=c(-2,0,2), line=0.3, col="blue", cex=0.9)
mtext(-1:1, side=2, las=1, at=-1:1, line=0.2, col="blue", cex=0.9)

par(oldpar)

###########
# Ejercicio
###########

# Generar dos variables aleatorias de 10 números cada una 
# (normal y uniforme (-2,2)) y realizar un diagrama bivariado (plot) 
# en el que aparezca, a parte de los elementos principales 
# (título, subtítulo, etiquetado de los ejes...), una flecha
# que vaya desde el punto (0,0) al punto (0.7,0.7) 
# y añadir justo en esta coordenada otro punto (en color verde para
# distinguirlo). Añadir la etiqueta "punto verde" encerrada en una caja 
# (rectángulo).
# Añadirle en la esquina izquierda la fórmula y=1/sen(x).

# Solución:

x <- rnorm(10)
y <- runif(10, -2, 2)
plot(x,y, xlab="datos x", ylab="datos y")
title(main="El título", sub="El subtítulo")
arrows(0,0,0.7,0.7)
points(x=0.7, y=0.7, pch=20, col="green", cex=2) # mejor la flecha después
text(0.7,0.7,labels="punto verde", pos=4)
# legend(0.7,0.7,legend="punto verde")
legend("bottomleft", legend=expression(y == 1/sin(x)))
