####################
# Data Import/Export
####################

# Un exemple a partir d'un arxiu SPSS 

# setwd("C:/Archivos de programa/SPSS")

# Read Data Stored by 'Minitab', 'S', 'SAS', 'SPSS', 'Stata', 'Systat', 'Weka', 'dBase', ...
library(foreign)
################

?read.spss

# https://stats.oarc.ucla.edu/spss/dae/logit-regression/
# Example 2
binary <- read.spss("binary.sav")
class(binary) # no s un data.frame
is.factor(binary$admit)

coches <- read.spss("coches.sav")
names(coches)
class(coches$ORIGEN)

is.factor(coches$CONSUMO)
is.numeric(coches$CILINDR)

levels(coches$ORIGEN)

length(coches$CONSUMO)

summary(coches)

# Import and Export 'SPSS', 'Stata' and 'SAS' Files 
library(haven)
##############
binary <- read_spss("binary.sav")
class(binary)

summary(binary)

coches <- read_spss("coches.sav")
names(coches)
class(coches$ORIGEN)

is.factor(coches$CONSUMO)
is.numeric(coches$CILINDR)

levels(coches$ORIGEN)
is.factor(coches$ORIGEN)

length(coches$CONSUMO)

summary(coches)

# lectura des d'una pgina web

baseurl <- "https://stats.idre.ucla.edu/stat/data/"
address <- paste(baseurl,"binary.csv",sep='')
binary <- read.table(file=url(address), header=T, sep = ",")

# baseurl <- "https://www.ub.edu/cursosR"
# address <- paste(baseurl,"adeu.R",sep='')
# source(file=url(address)) # executa el script

###############
# Package RODBC
###############

setwd("D:/Mis documentos/R")
setwd("d:\\OneDrive - Universitat de Barcelona\\R\\Ejemplos\\")

library(RODBC)
canal <- odbcConnectAccess("peces.mdb", uid = "", pwd = "")
# odbcConnectAccess is only usable with 32-bit Windows
# Possibles solucions:
# https://www.anycodings.com/1questions/4387343/how-to-connect-r-with-access-database-in-64-bit-window
canal

# Per saber les taules que cont la base de dades

sqlTables(canal)

# La informaci permet generar els data.frames amb la instrucci sqlFetch

proveidors <- sqlFetch(canal, "Proveidors")
parts <- sqlFetch(canal, "Parts")
remeses <- sqlFetch(canal, "Remeses")

# Sn tres data.frames

proveidors[1:3,]
parts[1:3,]
remeses[1:3,]

dim(proveidors);dim(parts);dim(remeses)
colnames(proveidors)

# Per tamb podem fer una "query" directa

sqlQuery(canal, "select [Nom proveIdor], Ciutat from Proveidors")

# una consulta molt ms complexe

sqlQuery(canal, "select [Nom proveIdor], Ciutat from Proveidors where [Prov#] in (select [Prov#] from Remeses where Quantitat > 250)")

# la mateixa consulta amb un "paste"

sqlQuery(canal, paste("select [Nom proveIdor], Ciutat from Proveidors ",
                      "where [Prov#] in ",
                      "(select [Prov#] from Remeses where Quantitat > 250)"
                      )
        )

# Consultes d'acci
        
sqlQuery(canal, "insert into Proveidors ([Prov#], [Nom proveIdor], Estat, Ciutat) values ('Pr4', 'Gutierrez', 40, 'Roma')") 
sqlFetch(canal, "Proveidors")

sqlQuery(canal, "delete * from Proveidors where [Prov#] = 'Pr4'") 
sqlFetch(canal, "Proveidors")

# Crear una taula en la base de dades

# sqlQuery(canal, "CREATE TABLE Venedors (Nom TEXT (25) , Cognoms TEXT (50))")

# Tamb a partir d'un data.frame

L3 <- LETTERS[1:3]
(d <- data.frame(cbind(x=1, y=1:10), fac=sample(L3, 10, repl=TRUE)))
Taula <- d
sqlSave(canal, Taula)

# borrar una taula de la base de dades

sqlDrop(canal, "Taula")

## Tancar la connexi

odbcClose(canal)
