data(iris)
attach(iris)
head(iris)
y <- iris[,1]
x <- iris[,2]
idx.se <- Species=="setosa"
idx.ve <- Species=="versicolor"
idx.vi <- Species=="virginica"
lm.setosa <- lm(y[idx.se] ~ x[idx.se])
lm.versicolor <- lm(y[idx.ve] ~ x[idx.ve])
lm.virginica <- lm(y[idx.vi] ~ x[idx.vi])

residuos <- c(lm.setosa$residuals,lm.versicolor$residuals,lm.virginica$residuals)
residuos <- c(lm.setosa$residuals,lm.virginica$residuals)
library(car)
levene.test(residuos,Species[c(1:50,101:150)])

plot(x,y,xlab="width",ylab="length",type="n")
title("Sepal.Length vs Sepal.Width")
points(x[idx.se],y[idx.se],pch=16,col="orange")
points(x[idx.ve],y[idx.ve],pch=16,col="red")
points(x[idx.vi],y[idx.vi],pch=16,col="brown")
abline(lm.setosa,lwd=1.5,col="orange")
abline(lm.versicolor,lwd=1.5,col="red")
abline(lm.virginica,lwd=1.5,col="brown")



detach(iris)