################################
# MA example
################################

library(MASS)
data(crabs)

cp <- prcomp(crabs[, -c(1,2,3)])
cp

plot(cp$x[, 1], cp$x[, 2], col = ifelse(crabs$sp == "O", "orange","blue"), 
                           pch = 16, xlab = "PC.1", ylab = "PC.2")

library(scatterplot3d)
scatterplot3d(CL, CW, RW, color = ifelse(crabs$sp == "O", "orange","blue"))
scatterplot3d(cp$x[, 1], cp$x[, 2], cp$x[, 3], 
              color = ifelse(crabs$sp == "O", "orange", "blue"), 
              pch = ifelse(crabs$sex == "M", 1, 15))
        
# 2D graphic
library(plotly)
datos <- data.frame(cp$x)
fig2D <- plot_ly(data=datos, x=~PC1, y=~PC2, 
                 color=~crabs$sp, colors="Set1")
fig2D


fig3D <- plot_ly(data=datos, x = ~PC1, y = ~PC2, z = ~PC3, 
               color = ~crabs$sp, colors = c("blue","orange"),
               symbol = ~crabs$sex, symbols = c('circle','o'))
fig3D




